POJ 1015 陪审团问题
题意略。
思路:
这个题目开始我本来打算用个二维dp,令dp[ i ][ j ]为考虑前i个人,有j个名额的时候,我所能获取的最小差,后来发现不好转移。因为dp[ i ][ j ]有可能是+2,
也有可能是-2,这两种值对我以后的求解可能都有用。后来想再添加一维,dp[ i ][ j ][ 0 ]表示正值的最小,dp[ i ][ j ][ 1 ]表示负值的最小(绝对值的最小)。
这样dp逻辑又很复杂。最后参考了网上的解法,于是将状态定义为:
dp[ i ][ j ][ k ]表示在前i个人里考虑,有j个名额,使得sigma(p) - sigma(d)为k时,我所能获得的sigma(p + d)的最大值。
状态转移方程:dp[ i ][ j ][ k ] = max(dp[i - 1][ j ][ k ] , dp[i - 1][j - 1][k - p[i] + d[i] ] + p[ i ] + d[ i ])
只可惜我做题时只想到了正负值的问题,没有更进一步将正负值直接确定为差值,然后dp对象为p + d,从而满足题目中的第二个条件。
有时dp对象可以是次要条件,而不是首要条件,换一种方向去思考问题。
内存很紧张
//#include<bits/stdc++.h>
#include<iostream>
#include<algorithm>
#include<cstdio>
#include<cstring>
using namespace std;
const int maxn1 = ;
const int maxn2 = ;
const int maxn3 = ;
const int mid = maxn3>>;
const int F = 0x3f;
const int INF = 0x3f3f3f3f; struct node{
int peo,place,sub;
node(int peo = ,int place = ,int sub = ){
this->peo = peo,this->place = place,this->sub = sub;
}
}; int p[maxn2],d[maxn2],dp[maxn2][maxn1][maxn3],store[maxn2],n,m;
node path[maxn2][maxn1][maxn3]; int main(){
int cas = ;
while(scanf("%d%d",&n,&m) == && (n + m)){
for(int i = ;i <= n;++i) scanf("%d%d",&p[i],&d[i]);
int total = * m;
int low = mid - total,up = mid + total; for(int i = ;i <= n;++i){
for(int j = ;j <= m;++j){
for(int k = low;k <= up;++k){
dp[i][j][k] = -;
path[i][j][k] = node(-,-,-);
}
}
} for(int i = ;i <= n;++i) dp[i][][mid] = ; for(int i = ;i <= n;++i){
int bound = min(i,m);
for(int j = ;j <= bound;++j){
for(int k = low;k <= up;++k){
int part1 = dp[i - ][j][k];
int part2 = (k - p[i] + d[i] < low || k - p[i] + d[i] > up || dp[i - ][j - ][k - p[i] + d[i]] == -) ? - : dp[i - ][j - ][k - p[i] + d[i]] + p[i] + d[i];
dp[i][j][k] = max(part1,part2);
if(part1 == - && part2 == -) continue;
if(part1 > part2) path[i][j][k] = node(i - ,j,k);
else path[i][j][k] = node(i - ,j - ,k - p[i] + d[i]);
}
}
}
int idx;
for(int i = ;i <= total;++i){
int lft = mid - i,rht = mid + i;
int maxx = max(dp[n][m][lft],dp[n][m][rht]);
if(maxx == -) continue;
if(maxx == dp[n][m][lft]) idx = lft;
else idx = rht;
if(maxx != -) break;
}
int tail = ;
for(int i = n,j = m,k = idx;i != -;){
node temp = path[i][j][k];
int nxti = temp.peo;
int nxtj = temp.place;
int nxtk = temp.sub;
if(nxti == -) break;
if(nxtj < j) store[tail++] = i;
i = nxti,j = nxtj,k = nxtk;
}
int ans1 = ,ans2 = ;
for(int i = ;i < tail;++i){
ans1 += p[store[i]];
ans2 += d[store[i]];
}
printf("Jury #%d\n",cas++);
printf("Best jury has value %d for prosecution and value %d for defence:\n",ans1,ans2);
for(int i = tail - ;i >= ;--i) printf(" %d",store[i]);
printf("\n\n");
}
return ;
} /*
4 2
1 2
2 3
4 1
6 2 10 5
3 8
15 8
11 8
7 8
1 8
17 8
8 8
2 8
13 8
3 8 5 3
13 11
3 17
15 20
6 13
17 9 8 5
3 5
17 16
6 0
17 10
6 14
3 19
4 13
0 17
*/
POJ 1015 陪审团问题的更多相关文章
- OpenJudge 2979 陪审团的人选 / Poj 1015 Jury Compromise
1.链接地址: http://bailian.openjudge.cn/practice/2979 http://poj.org/problem?id=1015 2.题目: 总Time Limit: ...
- 背包系列练习及总结(hud 2602 && hdu 2844 Coins && hdu 2159 && poj 1170 Shopping Offers && hdu 3092 Least common multiple && poj 1015 Jury Compromise)
作为一个oier,以及大学acm党背包是必不可少的一部分.好久没做背包类动规了.久违地练习下-.- dd__engi的背包九讲:http://love-oriented.com/pack/ 鸣谢htt ...
- HDU POJ 1015 Jury Compromise(陪审团的人选,DP)
题意: 在遥远的国家佛罗布尼亚,嫌犯是否有罪,须由陪审团决定.陪审团是由法官从公众中挑选的.先随机挑选n个人作为陪审团的候选人,然后再从这n个人中选m人组成陪审团.选m人的办法是:控方和辩方会根据对候 ...
- POJ 1015 Jury Compromise 2个月后重做,其实这是背包题目
http://poj.org/problem?id=1015 题目大意:在遥远的国家佛罗布尼亚,嫌犯是否有罪,须由陪审团决定.陪审团是由法官从公众中挑选的.先随机挑选n个人作为陪审团的候选人,然后再从 ...
- (最优m个候选人 和他们的编号)Jury Compromise (POJ 1015) 难
http://poj.org/problem?id=1015 Description In Frobnia, a far-away country, the verdicts in court t ...
- POJ 1015 Jury Compromise dp分组
第一次做dp分组的问题,百度的~~ http://poj.org/problem?id=1015 题目大意:在遥远的国家佛罗布尼亚,嫌犯是否有罪,须由陪审团决定.陪审团是由法官从公众中挑选的.先随机挑 ...
- [Poj 1015] Jury Compromise 解题报告 (完全背包)
题目链接:http://poj.org/problem?id=1015 题目: 题解: 我们考虑设计DP状态(因为这很显然是一个完全背包问题不是吗?) dp[j][k]表示在外层循环到i时,选了j个人 ...
- POJ #1015 - Jury Compromise - TODO: POJ website issue
(poj.org issue. Not submitted yet) This is a 2D DP problem, very classic too. Since I'm just learnin ...
- poj 1015 Jury Compromise_dp
题意:n个陪审团,每个陪审团有x,y值,选出m个陪审团,要求 (sum(xi)-sum(yi))最少,当 (sum(xi)-sum(yi))最少有多个,取sum(xi)+sum(yi)最大那个 ,并顺 ...
随机推荐
- sql LocalDB 的安装环境和使用方法
LocalDB LocalDB专门为开发商.它是非常容易安装,无需管理,但它提供了相同的T-SQL语言,编程表面和客户端供应商定期的SQL Server Express.实际上,目标SQL Serve ...
- hive show databases 添加条件
show databases like 'test012301' ; 通配符: show databases like 'a*';
- 云计算:Linux运维核心管理命令详解
云计算:Linux运维核心管理命令详解 想做好运维工作,人先要学会勤快: 居安而思危,勤记而补拙,方可不断提高: 别人资料不论你用着再如何爽那也是别人的: 自己总结东西是你自身特有的一种思想与理念的展 ...
- PHP-1.数据库连接与登陆
<?php //数据库信息 $servername = "localhost"; $username = "root"; $password = &quo ...
- mybatis-Generator 代码自动生成报错 Result Maps collection already contains value for BaseResultMap
原因: 如果不把之前已经生成的xxxMapper.xml删除掉,再次生成代码时,会附加上去! 运行项目就回报上面的错误. 所以在运行代码生成之前,要把以前已经生成的xml文件清掉,以妨出错.
- Spring MVC中的 权限拦截定义 以及 权限拦截的研发步骤
权限拦截 (拦截器: 对请求进行区分) 1 实现的价值(作用) 用户未登录:访问没用登录的URL,拦截到以后 跳转回登录 用户未登录:访问登录的URL,直接放行到后续流程处理框架,进行后续的操作 用户 ...
- Appium+python自动化(二十五)- 那些让人抓耳挠腮、揪头发和掉头发的事 - 获取控件ID(超详解)
简介 在前边的第二十二篇文章里,已经分享了通过获取控件的坐标点来获取点击事件的所需要的点击位置,那么还有没有其他方法来获取控件点击事件所需要的点击位置呢?答案是:Yes!因为在不同的大小屏幕的手机上获 ...
- ubuntu中设置python默认版本
看/usr/bin中的Python文件,发现该文件是python2.7的链接文件 于是直接删掉这个软链接,然后重新创建python2.6的链接文件: 1 rm /usr/bin/python 2 ln ...
- 在 dotnet core (C#)下的颜色渐变
直接使用等比例抽样算法,连同透明度一起计算. public IList<Color> ShadeColors(Color c1, Color c2, int resultCount) { ...
- c#链接数据库,查找数据信息
using System;using System.Collections.Generic;using System.Linq;using System.Text;using System.Threa ...